Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## PER.rover
Class SmartWanderAction

    java.lang.Object
      PER.rover.SmartWanderAction

All Implemented Interfaces:
  Action, java.io.Serializable

public class SmartWanderAction
extends java.lang.Object
implements Action

Allows the rover to explore an area without running in to things. The rover will drive in a straight line until it encounters an obstacle, then it turns on the light to examine the obstacle. The rover then chooses a random angle, checks if the new heading is unobstructed, and drives in the new direction. If the rover does not see a clear area after checking several angles, it will turn in the hope of finding a better path from the new vantage point.

See Also:
  Serialized Form

Constructor Summary
`SmartWanderAction(int seconds)` Creates a new instance of SmartWanderAction that takes pictures as it moves.
`SmartWanderAction(int seconds, boolean takePictures)` Creates a new instance of SmartWanderAction.

Method Summary
`boolean` | `doAction(Rover r)` Tries to start the action.
`long` | `getImageUpdateTime()` Lets you know when the last image was taken by this action.
`java.awt.image.BufferedImage` | `getRecentImage()` Returns the most recent image taken by this Action.
`int` | `getReturnValue()` The return value of the Action.
`java.lang.String` | `getShortSummary()` Provides a shortened version of the summary returned by getSummary.
`java.lang.String` | `getSummary()` Provides a textual explanation of the Action, such as "turn 90 degrees"
`int` | `getTime()` How long the action will take, in milliseconds.
`int` | `getTimeRemaining()` How much time until the action finishes (in milliseconds), if it has already started.
`boolean` | `isCompleted()` Whether the action has completed.
`boolean` | `isSuccess()` Returns true if the time limit expired without the occurance of any errors.
`void` | `kill()` Emergency stop - end the action immediately, if it's running.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SmartWanderAction

    public SmartWanderAction(int seconds)

  Creates a new instance of SmartWanderAction that takes pictures as it moves. Use Rover.receive.getRecentImage() to get the pictures as the robot is driving.

Parameters:
  `seconds` - the length of time to wander in seconds

### SmartWanderAction

    public SmartWanderAction(int seconds,
                             boolean takePictures)

  Creates a new instance of SmartWanderAction. If the rover is taking pictures, use Rover.receive.getRecentImage() to get the pictures as the robot is driving.

Parameters:
  `seconds` - the length of time to wander in seconds
  `takePictures` - if true, the rover will take pictures while turning and driving

Method Detail

### doAction

    public boolean doAction(Rover r)

  Description copied from interface: `Action`
  Tries to start the action. Returns whether the action started.

  Specified by:
    `doAction` in interface `Action`

### getReturnValue

    public int getReturnValue()

  Description copied from interface: `Action`
  The return value of the Action. Zero is a success. Negative implies one of this class's constants. Other values should be interpreted as appropriate.

  Specified by:
    `getReturnValue` in interface `Action`
  See Also:
    `RoverState`, `ActionConstants`

### getShortSummary

    public java.lang.String getShortSummary()

  Description copied from interface: `Action`
  Provides a shortened version of the summary returned by getSummary. For example, getSummary may return something like "Turn left and drive about 39 inches toward the red landmark," whereas getShortSummary might just return "Drive toward a landmark."

  Specified by:
    `getShortSummary` in interface `Action`

### getSummary

    public java.lang.String getSummary()

  Description copied from interface: `Action`
  Provides a textual explanation of the Action, such as "turn 90 degrees"

  Specified by:
    `getSummary` in interface `Action`

### getTime

    public int getTime()

  Description copied from interface: `Action`
  How long the action will take, in milliseconds.

  Specified by:
    `getTime` in interface `Action`

### getTimeRemaining

    public int getTimeRemaining()

  Description copied from interface: `Action`
  How much time until the action finishes (in milliseconds), if it has already started. Undefined behavior if the action has not yet begun, or has finished.

  Specified by:
    `getTimeRemaining` in interface `Action`

### isCompleted

    public boolean isCompleted()

  Description copied from interface: `Action`
  Whether the action has completed. Undefined until doAction has been called.

  Specified by:
    `isCompleted` in interface `Action`

### isSuccess

    public boolean isSuccess()

  Returns true if the time limit expired without the occurance of any errors.

  Specified by:
    `isSuccess` in interface `Action`

### kill

    public void kill()

  Description copied from interface: `Action`
  Emergency stop - end the action immediately, if it's running.

  Specified by:
    `kill` in interface `Action`

### getImageUpdateTime

    public long getImageUpdateTime()

  Description copied from interface: `Action`
  Lets you know when the last image was taken by this action. If the Action does not take pictures or the first picture has not yet been taken, will return 0.

  Specified by:
    `getImageUpdateTime` in interface `Action`
  Returns:
    the system time in milliseconds when the last image was taken or 0 if no images have been taken

### getRecentImage

    public java.awt.image.BufferedImage getRecentImage()

  Description copied from interface: `Action`
  Returns the most recent image taken by this Action. The image will be null if the Action does not take pictures or the first picture has not yet been taken.

  Specified by:
    `getRecentImage` in interface `Action`
  Returns:
    the most recent picture taken by the Action.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD